Name

    EXT_get_proc_address

Name Strings

    GLU_EXT_get_proc_address

Contact

    Brian Paul, (brian_paul 'at' mesa3d.org)

Status

    Planned for Mesa 3.1 GLU and other GLU implementations.

Version

    $Id: GLU_EXT_get_proc_address.spec,v 1.2 1999/09/16 20:50:02 brianp Exp $

Number

    ???

Dependencies

    The extension is written against the OpenGL GLU 1.3 specification.

Overview

    This extension adds a function (gluGetProcAddressEXT) which returns
    the address of GLU extension functions, given the function name.
    This extension is in the spirit of wglGetProcAddress.

Issues

  * Should a typedef be used for the return type?

        typedef void (*GLfunction)();
        extern GLfunction gluGetProcAddressEXT(const GLubyte *procName);

        Not needed.  The following works:

        void (*gluGetProcAddressEXT(const GLubyte *procName))();

  * Should gluGetProcAddressEXT allow querying of itself?

        Yes, for sake of completeness.

  * Should we only return pointers to extension functions which are
    indeed available?

        Yes, since it is easy to do and minimizes the chance of misuse
        by the programmer.  Unlike GLX or the core GL, GLU does not have
        device-specific modules.

  * Should the address of any post-1.0 GLU functions be queryable?

        Yes, it further simplifies the work of the programmer.

New Procedures and Functions

    void (*gluGetProcAddressEXT(const GLubyte *procName))()

New Tokens

    None.

Additions to the GLU Specification version 1.3, Chapter 2

    Append chapter 2 with the following new text:

    A pointer to a GLU extension function can be obtained with
        void (*gluGetProcAddressEXT(const GLubyte *procName))();

    The pointer returned by gluGetProcAddressEXT should be cast to a
    function type which matches the extension function's definition.

    NULL will be returned if either the extension isn't present or
    the particular function is not available.

    Any function added to GLU since version 1.0 may also be queried
    with gluGetProcAddressEXT.

Errors

    None.

New State

    None.

Revision History

  * Revision 1.1 - initial draft (13 Sep 1999)

  * Revision 1.2 - (16 Sep 1999)
                 - removed typedef'd return type
                 - miscellaneous clean-up
