Name

    EXT_get_proc_address

Name Strings

    GLX_EXT_get_proc_address

Contact

    Brian Paul, (brian_paul 'at' mesa3d.org)

Status

    Planned for Mesa 3.1 GLX and other GLX implementations.

Version

    $Id: GLX_EXT_get_proc_address.spec,v 1.1 1999/09/16 20:50:43 brianp Exp $

Number

    ???

Dependencies

    The extension is written against the OpenGL GLX 1.3 specification.

Overview

    This extension adds a function (glXGetProcAddressEXT) which returns
    the address of GLX extension functions, given the function name.
    This extension is in the spirit of wglGetProcAddress but only
    returns pointers to GLX functions.  Core GL extension functions should
    be queried with glGetProcAddressEXT.

Issues

  * Should a typedef be used for the return type?

        typedef void (*GLfunction)();
        extern GLfunction glXGetProcAddressEXT(const GLubyte *procName);

        Not needed.  The following works:

        void (*glXGetProcAddressEXT(const GLubyte *procName))();

  * Should glXGetProcAddressEXT allow querying of itself?

        Yes, for sake of completeness.

  * Should we only return pointers to extension functions which are
    indeed available?

        No.  Client should also query the version strings to determine
        if the extension is available.

  * Should the address of post-1.0 GLX functions be queryable?

        Yes, it further simplifies the work of the programmer.

New Procedures and Functions

    void (*glXGetProcAddressEXT(const GLubyte *procName))();

New Tokens

    None.

Additions to the OpenGL Specification version 1.2

    None.

Additions to the GLX Specification version 1.3, Chapter 3

    3.3.12 Extension Entry Points

    A pointer to a client-side GLX extension function can be obtained
    with
        void (*glXGetProcAddressEXT(const GLubyte *procName))();

    The pointer returned by glXGetProcAddressEXT should be cast to a
    function type which matches the extension function's definition.

    NULL will be returned if the particular function is not available.

    Any function added to GLX since version 1.0 may also be queried
    with glxGetProcAddressEXT.

Errors

    None.

New State

    None.

Revision History

  * Revision 1.1 - initial draft (16 Sep 1999)
