

/*
 *  this generates the offsets for those members of Mesa's structs, which we 
 *   need in asm.
 */

#include "types.h" 
#include "cva.h" 
#include "mmath.h" 
#include "FX/fxdrv.h" 
#include <stdio.h>

int main ( int argc, char** argv )
{
   struct vertex_buffer *VB;
   GLcontext *ctx;
   struct tfxMesaContext *tfxMesaCtx;

   printf ("/*  This file is autogenerated by %s                */\n", argv[0]);
   printf ("/*  Do not modify it per hand, just run %s.         */\n", argv[0]);
   printf ("\n"); 
   printf ("#ifndef _FX_REG_OFF_H\n"); 
   printf ("#define _FX_REG_OFF_H\n"); 
   printf ("\n"); 
   printf ("\n"); 
   printf ("#define  FX_VERTEX_SIZE               %i\n\n", 
            sizeof (fxVertex));
   
   printf ("#define  VB_COUNT                     %i\n", 
            ((int) &(VB->Count)) - ((int) VB));

   printf ("#define  VB_CLIPMASK                  %i\n", 
            ((int) &(VB->ClipMask)) - ((int) VB));

   printf ("#define  VB_DRIVERDATA                %i\n", 
            ((int) &(VB->driver_data))-((int) VB));

   printf ("#define  VB_DRIVERDATA_VERTS          %i\n", 
            ((int) &(FX_DRIVER_DATA(VB)->verts)) - ((int) FX_DRIVER_DATA(VB)));

   printf ("#define  VB_DRIVERDATA_LASTVERT       %i\n", 
            ((int) &(FX_DRIVER_DATA(VB)->last_vert)) - ((int) FX_DRIVER_DATA(VB)));

   printf ("#define  VB_CTX                       %i\n", 
            ((int) &(VB->ctx)) - ((int) VB));

   printf ("#define  VB_CTX_VIEWPORT_WINDOWMAP_M  %i\n", 
            ((int) &(ctx->Viewport.WindowMap.m))-((int) ctx));

   printf ("\n"); 
   printf ("#define  FX_CONTEXT_CTX               %i\n", 
            ((int) &(ctx->DriverCtx)-((int) ctx)));

   printf ("\n");
   printf ("\n"); 
   printf ("#endif\n"); 
   printf ("\n"); 

   return 0;
}

