#ifndef _FXVSETUP_H_
#define _FXVSETUP_H_


#define VARS_W  

#define VARS_Z

#define VARS_TMU0							\
  GLuint tmu0_source = fxMesa->tmu_source[0];				\
  GLfloat *tmu0_data = VEC_ELT(VB->TexCoordPtr[tmu0_source],		\
			       GLfloat, start);				\
  GLuint tmu0_stride = VB->TexCoordPtr[tmu0_source]->stride;		\
  GLuint tmu0_sz = VB->TexCoordPtr[tmu0_source]->size;			\
  struct gl_texture_unit *t0 = &ctx->Texture.Unit[tmu0_source];		\
  GLfloat sscale0 = FX_TEXTURE_DATA(t0)->sScale;	\
  GLfloat tscale0 = FX_TEXTURE_DATA(t0)->tScale;

#define VARS_TMU1							\
  GLuint tmu1_source = fxMesa->tmu_source[1];				\
  GLfloat *tmu1_data = VEC_ELT(VB->TexCoordPtr[tmu1_source],		\
			       GLfloat, start);				\
  GLuint tmu1_stride = VB->TexCoordPtr[tmu1_source]->stride;		\
  GLuint tmu1_sz = VB->TexCoordPtr[tmu1_source]->size;			\
  struct gl_texture_unit *t1 = &ctx->Texture.Unit[tmu1_source];		\
  GLfloat sscale1 = FX_TEXTURE_DATA(t1)->sScale;	\
  GLfloat tscale1 = FX_TEXTURE_DATA(t1)->tScale;

#define VARS_RGBA 						\
  GLubyte *color = VEC_ELT(VB->ColorPtr, GLubyte, start); 	\
  GLuint col_stride = VB->ColorPtr->stride; 

#define VARS_XY GLfloat *win = VB->Win.data[start]; 

#define INCR_XY win += 4


#ifdef FX_V2
#  define DO_SETUP_XY 				\
  v[XCOORD]=win[0];				\
  v[YCOORD]=win[1]; 
#else
#  if (defined(__linux__) && defined(__i386__)) || defined(macintosh)
#    define DO_SETUP_XY {			\
       GLfloat t1 = win[0] + snapper;	\
       GLfloat t2 = win[1] + snapper;	\
       v[XCOORD] = t1 - snapper;			\
       v[YCOORD] = t2 - snapper;			\
     }
#  else
#    define DO_SETUP_XY {				\
        /* trunc (x,y) to multiple of 1/16 */		\
        v[XCOORD]=((int)(win[0]*16.0f))*(1.0f/16.0f);	\
        v[YCOORD]=((int)(win[1]*16.0f))*(1.0f/16.0f);	\
     }
#  endif
#endif



#define DO_SETUP_W v[OOWCOORD]=win[3];

#define DO_SETUP_Z v[ZCOORD]=win[2];

#define DO_SETUP_TMU0					\
{							\
  v[S0COORD]=sscale0*tmu0_data[0]*v[OOWCOORD];		\
  v[T0COORD]=tscale0*tmu0_data[1]*v[OOWCOORD];		\
} 

#define INCR_TMU0 STRIDE_F(tmu0_data, tmu0_stride)

#define DO_SETUP_TMU1				\
{						\
  v[S1COORD]=sscale1*tmu1_data[0]*v[OOWCOORD];	\
  v[T1COORD]=tscale1*tmu1_data[1]*v[OOWCOORD];	\
}

#define INCR_TMU1 STRIDE_F(tmu1_data, tmu1_stride)

#define DO_SETUP_RGBA					\
{							\
  UBYTE_COLOR_TO_FLOAT_255_COLOR2(v[RCOORD], color[0]);	\
  UBYTE_COLOR_TO_FLOAT_255_COLOR2(v[GCOORD], color[1]);	\
  UBYTE_COLOR_TO_FLOAT_255_COLOR2(v[BCOORD], color[2]);	\
  UBYTE_COLOR_TO_FLOAT_255_COLOR2(v[ACOORD], color[3]);	\
}

#define INCR_RGBA color += col_stride


#define _FIXUP_PRE							\
   GLuint hs = fxMesa->stw_hint_state & ~(GR_STWHINT_W_DIFF_TMU0 |	\
					  GR_STWHINT_W_DIFF_TMU1);

#define _FIXUP_TMU0							\
   if (tmu0_sz == 4) {							\
      project_texcoords( VB, 0, tmu0_source, start, end );		\
      hs |= GR_STWHINT_W_DIFF_TMU0;			\
   } 


#define _FIXUP_TMU1							\
   if (tmu1_sz == 4) {							\
      project_texcoords( VB, 1, tmu1_source, start, end );		\
      hs |= GR_STWHINT_W_DIFF_TMU1;			\
   } 


#define _FIXUP_TMU01						\
   if (tmu0_sz == 4) {						\
      project_texcoords( VB, 0, tmu0_source, start, end );	\
      if (tmu1_sz == 4) 					\
	 project_texcoords( VB, 1, tmu1_source, start, end );	\
      else 							\
	 copy_w( VB, 1, start, end );				\
      hs |= (GR_STWHINT_W_DIFF_TMU0|GR_STWHINT_W_DIFF_TMU1);	\
   } else if (tmu1_sz == 4) {					\
      project_texcoords( VB, 1, tmu1_source, start, end );	\
      hs |= GR_STWHINT_W_DIFF_TMU1;				\
   }

#define _FIXUP_POST					\
   if (hs != fxMesa->stw_hint_state) {			\
      fxMesa->stw_hint_state = hs;			\
      FX_grHints(GR_HINT_STWHINT, hs);			\
   }


#define FIXUP_TMU0 { _FIXUP_PRE _FIXUP_TMU0 _FIXUP_POST }
#define FIXUP_TMU1 { _FIXUP_PRE _FIXUP_TMU1 _FIXUP_POST }
#define FIXUP_TMU01 { _FIXUP_PRE _FIXUP_TMU01 _FIXUP_POST }


/* v - pointer to destination GrVertex
 * VB - source of data
 * i - index into vb for data
 */


#endif
