/* $Id: vertices.h,v 1.3 1999/09/07 21:25:20 brianp Exp $ */

/*
 * Mesa 3-D graphics library
 * Version:  3.1
 * 
 * Copyright (C) 1999  Brian Paul   All Rights Reserved.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * BRIAN PAUL BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


#ifndef VERTICES_H_
#define VERTICES_H_

#ifdef VMS
#define gl_transform_points3_vertex16_general gl_transform_points3_vertex16_g
#endif

typedef void (*gl_transform_func)( GLfloat *first_vert,
				   const GLvector4f *vec,
				   const GLfloat *m,
				   GLuint count );

typedef void (*gl_cliptest_func)( GLfloat *first_vert,
				  GLfloat *last_vert, /* use count instead? */
				  GLubyte *or_mask,
				  GLubyte *and_mask,
				  GLubyte *clip_mask );


extern gl_transform_func gl_transform_points3_vertex16_general;
extern gl_cliptest_func gl_cliptest_points4_vertex16;			      

extern GLenum gl_reduce_prim[];
extern void gl_init_vertices(void);

#endif
